448. 找到所有数组中消失的数字
程序员文章站
2022-04-17 16:41:11
...
448. 找到所有数组中消失的数字
描述
给定一个范围在 1 ≤ a[i] ≤ n ( n = 数组大小 ) 的 整型数组,数组中的元素一些出现了两次,另一些只出现一次。
找到所有在 [1, n] 范围之间没有出现在数组中的数字。
您能在不使用额外空间且时间复杂度为O(n)的情况下完成这个任务吗? 你可以假定返回的数组不算在额外空间内。
示例:
输入:
[4,3,2,7,8,2,3,1]
输出:
[5,6]
思路
画图可见,对于顺序递增的1~n,对应位置的元素值=索引值+1。元素中存在重复,遍历数组,元素值-1得到其顺序递增时对应的下标,将该下标对应的元素值*-1置为负数,则再次遍历数组,有的元素值仍为正值,说明数组中不存在其索引+1对应的元素,这就是1–n中没有出现在数组中的数字。(即用正负值区分)
class Solution {
public List<Integer> findDisappearedNumbers(int[] nums) {
// Iterate over each of the elements in the original array
for (int i = 0; i < nums.length; i++) {
// Treat the value as the new index
//取绝对值的操作必不可少,因为前面可能已将该索引处的元素置相反数,因此每次计算新索引值
//时,用的都是元素值的绝对值。否则,索引值就可能为负值,导致结果判断错误。
int newIndex = Math.abs(nums[i]) - 1;
// Check the magnitude of value at this new index
// If the magnitude is positive, make it negative
// thus indicating that the number nums[i] has
// appeared or has been visited.
//>0的判断条件必不可少,因为前面可能已将该索引处的元素置相反数,当存在重复元素时,操作应
//当与第一次出现时相同,即均对新索引值对应的正元素取反。因此必须在元素值大于0的情况下,
//才能对元素*-1,否则,正反反复变化,会导致无法正确区分重复。
if (nums[newIndex] > 0) {
nums[newIndex] *= -1;
}
}
// Response array that would contain the missing numbers
List<Integer> result = new LinkedList<Integer>();
// Iterate over the numbers from 1 to N and add all those
// that have positive magnitude in the array
for (int i = 1; i <= nums.length; i++) {
if (nums[i - 1] > 0) {
result.add(i);
}
}
return result;
}
}
复杂度分析:
- 时间复杂度:O(N)。
- 空间复杂度:O(1),因为我们在原地修改数组,没有使用额外的空间。
推荐阅读
-
【LeetCode-⭐Hot100】448. 找到所有数组中消失的数字
-
LeetCode-448. 找到所有数组中消失的数字
-
LeetCode第448题找到所有数组中消失的数字(Python)
-
【leetcode】找到所有数组中消失的数字
-
【力扣Hot100】448. 找到所有数组中消失的数字
-
[ 热题 HOT 100]---448. 找到所有数组中消失的数字 ---哈希表/原地修改(秀的头皮发麻)
-
448. 找到所有数组中消失的数字
-
一个数组中只有两个数字是出现一次,其他所有数字都出现了两次, 找出这两个只出现一次的数字。
-
leetcode 448、645 —— 找到所有数组中消失的数字(错误的集合)
-
原地哈希表:力扣448. 找到所有数组中消失的数字